using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDataSource;

namespace TestGrid
{
    public partial class Form1 : Form
    {
        private const string bandNamePattern = "Band {0}";
        private int bandNameIndex;

        public Form1()
        {
            InitializeComponent();
            ultraGrid1.DisplayLayout.Override.ExpansionIndicator = Infragistics.Win.UltraWinGrid.ShowExpansionIndicator.CheckOnDisplay;
            TestCollection col = new TestCollection();
            col.CreateCollection();
            //ultraGrid1.DataSource = col;
            ultraGrid1.DataSource = ultraDataSource;
            
            foreach (TestClass data in col)
            {
                UltraDataRow dataRow = ultraDataSource.Rows.Add();
                dataRow.Tag = data;
                CreateChilds(data, dataRow);
            }
        }

        private void CreateChilds(TestClass data, UltraDataRow parentDataRow)
        {
            if (data.SubAccounts.Count == 0) return;
            UltraDataBand childBand = CreateChildBand(parentDataRow, bandNamePattern, bandNameIndex);
            foreach (TestClass childData in data.SubAccounts)
            {
                UltraDataRow dataRow = parentDataRow.GetChildRows(childBand).Add();
                dataRow.Tag = childData;
                CreateChilds(childData, dataRow);
            }
        }

        private UltraDataBand CreateChildBand(UltraDataRow parentDataRow, string bandNamePattern, int bandNameIndex)
        {
            UltraDataBand childDataBand = UltraDataSourceHelper.CreateChildBand(parentDataRow, bandNamePattern, bandNameIndex);
            if (!ultraGrid1.DisplayLayout.Bands.Exists(childDataBand.Key))
            {
                ultraGrid1.DataBind();
                if (!ultraGrid1.DisplayLayout.Bands.Exists(childDataBand.Key))
                {
                    throw new InvalidOperationException(String.Format("Child grid band '{0}' cannot be created.", childDataBand.Key));
                }
            }

            return childDataBand;
        }

        private void OnCellDataRequested(object sender, CellDataRequestedEventArgs e)
        {
            TestClass data = e.Row.Tag as TestClass;
            if (data == null) return;
            

            switch (e.Column.Key)
            {
                case "AccountID":
                    e.Data = data.AccountID;
                    break;
                case "Number":
                    e.Data = data.Number;
                    break;
            }
        }
    }
}